import os
import time
import numpy 
from pylab import *
import dateutil
from qgis.utils import iface
import matplotlib.pyplot as plt


layer = qgis.utils.iface.activeLayer() #selection de la couche en cours d'utilisation 


i='2013-01' #variable de la date de départ MODIFIABLE
k='2013-12' # variable de la date de fin MODIFIABLE
p='RER_A' #MODIFIABLE
q='RER_D' #MODIFIABLE



##selection des colonnes 'toto', 'titi','tata' par la detection du numero de colonne inscrit par la fenetre
cold = layer.fieldNameIndex(p) #detection numero de col depart
colf = layer.fieldNameIndex(q) #detection numero de col fin 


##creation de listes vides
abscisses = [] #Liste vide pour les abscisses
ordonnees=[[] for a in range (cold,colf+1)] #pareil pour l'ordonnee avec une condition de a inclus 
#entre cold et colf qui developpe a * ([])


##selection de toutes les donnees en abscisse, de la colonne date dans liste
for ligne in layer.getFeatures(): #importation ligne par ligne des attributs du shape
	#on nomme la fonction 'op' qui est egale a 
	#"dans la colonne date, on selectionne les lignes" 
    abscisses.append(ligne['date'])


##traduction des valeurs introduites en abscisses (ici date) en index (soit le numero de la ligne)
bla=abscisses.index(i) 
blo=abscisses.index(k)


#definition de la boucle pour selectionner les donnees
tp=[] #definition d'une liste vide
for ligne in layer.getFeatures():  #pareil que precedement 
    op=abscisses.index(ligne['date']) #creation de "op" qui comprend la liste des valeurs index de la colonne 'date' 
    a=0 #compteur
    if int(op)>=(bla) and int(op)<=(blo): #delimitation des bornes de debut et fin pour les dates a selectionner 
    #par condition
        tp.append(int(op)) #si op est compris entre bla et blo (les dates choisies), alors on ajoute dans la liste 'tp' 
        #les valeurs index comprises dans cette borne [bla;blo]
        while (cold+a)<=colf : #Boucle : tant que cold+a est inférieur à colf
            ordonnees[a].append(ligne[cold+a]) # pour l'ordonnee, on inclut les donnees des colonnes choisies 
            #par exemple, ordonnees[0] contient les valeurs de la colonne cold
            a+=1 #fin de la boucle pour revenir à a=a+1


##insertion des listes dans des matrices (pour avoir x et y dans la meme dimension)
n_dates=numpy.array(tp) #matrice pour x
n_ordonnees=numpy.array(ordonnees) #matrice pour y


##selection du nom des champs (pour la legende) 
fields=layer.pendingFields()
fieldus=[field.name() for field in fields]


##generescence du graph   
z=0 #nouveau compteur pour boucle
while (cold+z)<=(colf): #pareil que la boucle precedente
	plot(n_dates, n_ordonnees[z], ls='-', label=fieldus[cold+z]) #on pose les conditions du graph soit 
	#(x,y,la couleur des courbes(modifiable par une autre boucle, type de ligne)
	z+=1 #fin de la boucle


##definition d'une autre boucle pour la nomination des noms en abscisse pour le graphique
liste=[]
for ligne in layer.getFeatures():  
    liste.append(ligne['date'])

##Mise en page du graphique
plt.xlim()
plt.ylim()
plt.title('Releve de la ponctualite pour les RER de la gare de Chatelet-Les-Halles en 2013') # insertion du titre 
plt.xlabel('mois') #insertion du nom de l'abscisse
plt.ylabel('Taux de ponctualite') #pareil pour l'ordonnee
plt.xticks(n_dates, liste)
plt.legend()
plt.grid(True, 'major', 'y', ls='--', lw=.5, c='k', alpha=.3) #creation de pointilles
plt.legend()

plt.show() #execution du graph 


